<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Conecta 4</title>
    <style>
        /* Estilos CSS para el tablero y los botones */
        .container {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            height: 100vh;
        }

        .board {
            display: grid;
            grid-template-columns: repeat(7, 100px);
            grid-template-rows: repeat(6, 100px);
            grid-gap: 5px;
        }

        .cell {
            width: 100px;
            height: 100px;
            border: 1px solid black;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 24px;
        }

        .error-message {
            color: red;
            font-weight: bold;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>CONECTA 4</h1>
        <div class="error-message" id="errorMessage"></div>
        <div class="board"></div>
        <button id="resetButton">Reiniciar</button>
    </div>

    <script>
        class Player {
            constructor(name, symbol) {
                this.name = name;
                this.symbol = symbol;
                this.victories = 0;
                this.defeats = 0;
            }
        }

        class Board {
            constructor() {
                this.rows = 6;
                this.columns = 7;
                this.grid = Array.from({ length: this.rows }, () => Array.from({ length: this.columns }, () => ''));
            }

            render() {
                const boardElement = document.querySelector('.board');
                boardElement.innerHTML = '';
                this.grid.forEach((row, rowIndex) => {
                    row.forEach((cell, colIndex) => {
                        const cellElement = document.createElement('div');
                        cellElement.classList.add('cell');
                        cellElement.dataset.row = rowIndex;
                        cellElement.dataset.column = colIndex;
                        cellElement.textContent = cell;
                        cellElement.addEventListener('click', () => handleMove(colIndex));
                        boardElement.appendChild(cellElement);
                    });
                });
            }

            placeToken(column, player) {
                for (let row = this.rows - 1; row >= 0; row--) {
                    if (this.grid[row][column] === '') {
                        this.grid[row][column] = player.symbol;
                        return row; // Devolver la fila en la que se colocó la ficha
                    }
                }
                return -1; // Columna llena
            }
        }

        class Connect4Game {
            constructor(player1Name, player2Name) {
                this.players = [
                    new Player(player1Name, 'X'),
                    new Player(player2Name, 'O')
                ];
                this.currentPlayerIndex = 0;
                this.board = new Board();
                this.setupResetButton();
            }

            start() {
                this.board.render();
            }

            handleMove(column) {
                const currentPlayer = this.players[this.currentPlayerIndex];
                const row = this.board.placeToken(column, currentPlayer);
                if (row !== -1) {
                    if (this.checkWinner(row, column)) {
                        currentPlayer.victories++;
                        alert(currentPlayer.name +' ha ganado!');
			this.sendGameResults();
                        this.resetGame();
                    } else {
                        this.currentPlayerIndex = (this.currentPlayerIndex + 1) % 2;
                    }
                } else {
                    alert('¡La columna está llena!');
                }
                this.board.render();
            }

           sendGameResults() {
    var winnerName = this.players[0].name;
    const loserName =this.players[1].name;
    const victoriesWinner =this.players[0].victories;
    const defeatsWinner =this.players[1].victories;
    const victoriesLoser =this.players[1].victories;
    const defeatsLoser =this.players[0].victories;

    const formData = new FormData();
    formData.append('nombreJugador1', winnerName);
    formData.append('victoriasJugador1', victoriesWinner);
    formData.append('derrotasJugador1', defeatsWinner);
    formData.append('nombreJugador2', loserName);
    formData.append('victoriasJugador2', victoriesLoser);
    formData.append('derrotasJugador2', defeatsLoser);

    fetch('guardar_datos.php', {
        method: 'POST',
        body: formData
    })
    .then(response => {
        return response.text(); // Convertir la respuesta a texto
    })
    .then(data => {
        // Mostrar la respuesta del servidor en el div de mensaje
        document.getElementById('message').innerHTML = data;
    })
    .catch(error => {
        console.error('Error:', error);
        // Mostrar un mensaje de error en caso de que falle la solicitud
        document.getElementById('message').innerHTML = 'Error al procesar la solicitud';
    });
}

	checkWinner(row, column) {
                const symbol = this.board.grid[row][column];

                // Verificar horizontalmente
                let count = 0;
                for (let i = 0; i < this.board.columns; i++) {
                    if (this.board.grid[row][i] === symbol) {
                        count++;
                        if (count === 4) return true; // Cuatro en línea
                    } else {
                        count = 0;
                    }
                }

                // Verificar verticalmente
                count = 0;
                for (let i = 0; i < this.board.rows; i++) {
                    if (this.board.grid[i][column] === symbol) {
                        count++;
                        if (count === 4) return true; // Cuatro en línea
                    } else {
                        count = 0;
                    }
                }

                // Verificar diagonalmente (de izquierda a derecha)
                count = 0;
                let startRow = row - Math.min(row, column);
                let startColumn = column - Math.min(row, column);
                while (startRow < this.board.rows && startColumn < this.board.columns) {
                    if (this.board.grid[startRow][startColumn] === symbol) {
                        count++;
                        if (count === 4) return true; // Cuatro en línea
                    } else {
                        count = 0;
                    }
                    startRow++;
                    startColumn++;
                }

                // Verificar diagonalmente (de derecha a izquierda)
                count = 0;
                startRow = row + Math.min(this.board.rows - row - 1, column);
                startColumn = column - Math.min(this.board.rows - row - 1, column);
                while (startRow >= 0 && startColumn < this.board.columns) {
                    if (this.board.grid[startRow][startColumn] === symbol) {
                        count++;
                        if (count === 4) return true; // Cuatro en línea
                    } else {
                        count = 0;
                    }
                    startRow--;
                    startColumn++;
                }

                return false; // No hay ganador
            }

            setupResetButton() {
                const resetButton = document.getElementById('resetButton');
                resetButton.addEventListener('click', () => this.resetGame());
            }

            resetGame() {
                const player1Name = prompt("Ingrese el nombre del jugador 1:");
                const player2Name = prompt("Ingrese el nombre del jugador 2:");
                this.players = [
                    new Player(player1Name, 'X'),
                    new Player(player2Name, 'O')
                ];
                this.currentPlayerIndex = 0;
                this.board = new Board();
                this.board.render();
            }
        }

        // Función para mostrar mensajes de error
        function displayErrorMessage(message) {
            const errorMessageElement = document.getElementById('errorMessage');
            errorMessageElement.textContent = message;
        }

        // Función para manejar el movimiento del jugador
        function handleMove(column) {
            game.handleMove(column);
        }

        // Uso del juego
        const game = new Connect4Game();
        game.resetGame(); // Iniciar el juego pidiendo los nombres de los jugadores
    </script>
</body>
</html>
